local L = Capitalist.Locale
local realm = GetRealmName()
local character = UnitName("player")

local countPerPageProductUI = 13

function Capitalist:CreateAuctionUI()
	self:DebugEntry("CreateAuctionUI")

	self.auctionUIButton = CreateFrame("button", nil, AuctionFrameBrowse)
	local t = self.auctionUIButton
	t:SetPoint("TOPLEFT", AuctionFrame, "TOPLEFT", 20, -70)
	t:SetHeight(30)
	t:SetWidth(30)
	t:SetScript("OnClick", function() Capitalist:ToggleAuctionUI() end)
	t:Show()
	
	t.texture = t:CreateTexture()
	t.texture:SetAllPoints()
	t.texture:SetTexture("Interface\\Icons\\INV_Scroll_03")
	t.texture:SetDrawLayer("BACKGROUND")
	
	t.border = t:CreateTexture()
	t.border:SetAllPoints()
	t.border:SetTexture("Interface\\Buttons\\ButtonHilight-Square")
	t.border:SetBlendMode("ADD")
	t.border:SetDrawLayer("BORDER")
	t.border:Hide()
	t:SetScript("OnEnter", function(self) self.border:Show() end)
	t:SetScript("OnLeave", function(self) if (not Capitalist.auctionUI:IsVisible()) then self.border:Hide() end end)
	
	
	
	
	self.auctionUI = CreateFrame("frame", nil, AuctionFrameBrowse)
	t = self.auctionUI
	t:SetPoint("TOPLEFT", AuctionFrame, "TOPLEFT", 16, -101)
	t:SetPoint("BOTTOMRIGHT", AuctionFrame, "BOTTOMRIGHT", -7, 37)
	t:SetFrameStrata("HIGH")
	t:EnableMouse(true)
	t:Hide()
	
	t.background = t:CreateTexture(nil, "BACKGROUND")
	t.background:SetAllPoints()
	t.background:SetTexture(0,0,0)
	
	t.lastScanLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.lastScanLabel:SetText(L["Last Scan: "].."-")
	t.lastScanLabel:SetPoint("TOPLEFT", 10, -10)
	t.lastScanLabel:SetWidth(110)
	t.lastScanLabel:SetHeight(20)

	t.progress = t:CreateTexture()
	t.progress:SetPoint("LEFT", t.lastScanLabel, "LEFT")
	t.progress:SetWidth(110)
	t.progress:SetHeight(20)
	t.progress:SetTexture(0, 0, 1)
	t.progress:Hide()
	
	t.progressLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.progressLabel:SetAllPoints(t.lastScanLabel)
	
	t.scanButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.scanButton:SetWidth(110)
	t.scanButton:SetHeight(20)
	t.scanButton:SetPoint("TOPLEFT", t.lastScanLabel, "BOTTOMLEFT", 0, -5)
	t.scanButton:SetText(L["perform scan"])
	t.scanButton:SetScript("OnClick", function() Capitalist:StartScan() end)

	t.cancelButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.cancelButton:SetWidth(110)
	t.cancelButton:SetHeight(20)
	t.cancelButton:SetPoint("TOPLEFT", t.scanButton, "BOTTOMLEFT", 0, -5)
	t.cancelButton:SetText(L["cancel auctions"])
	t.cancelButton:SetScript("OnClick", function() Capitalist:CancelAuctions() end)
	t.cancelButton:Disable()

	t.postButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.postButton:SetWidth(110)
	t.postButton:SetHeight(20)
	t.postButton:SetPoint("TOPLEFT", t.cancelButton, "BOTTOMLEFT", 0, -5)
	t.postButton:SetText(L["post products"])
	t.postButton:SetScript("OnClick", function() Capitalist:StartPost() end)
	t.postButton:Disable()
	
	t.items = {}
	for i = 1, countPerPageProductUI do
		t.items[i] = CreateFrame("frame", nil, t)
		local item = t.items[i]
		item:SetWidth(500)
		item:SetHeight(20)
		item:SetPoint("TOPLEFT", t, "TOPLEFT", 250, -20*i)
		
		item.name = item:CreateFontString(nil, nil, "GameFontNormal")
		item.name:SetWidth(220)
		item.name:SetPoint("TOPLEFT")
		item.name:SetText("")
		item.name:SetJustifyH("LEFT")
		
		item.money = item:CreateFontString(nil, nil, "GameFontNormal")
		item.money:SetWidth(150)
		item.money:SetPoint("LEFT", item.name, "RIGHT")
		item.money:SetText("")
		item.money:SetJustifyH("LEFT")
		
		item.count = item:CreateFontString(nil, nil, "GameFontNormal")
		item.count:SetPoint("LEFT", item.money, "RIGHT")
		item.count:SetWidth(70)
		item.count:SetText("")
		
		item.lowest = item:CreateFontString(nil, nil, "GameFontNormal")
		item.lowest:SetPoint("LEFT", item.count, "RIGHT")
		item.lowest:SetWidth(70)
		item.lowest:SetText("")
	end
	
	t.page = 0
	
	t.prevButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.prevButton:SetWidth(30)
	t.prevButton:SetHeight(20)
	t.prevButton:SetText("<<")
	t.prevButton:SetPoint("TOPLEFT", t.items[countPerPageProductUI], "BOTTOMLEFT")
	t.prevButton:SetScript("OnClick", function()
										local i = Capitalist.auctionUI.page
										if (i > 0) then i = i - 1 end
										Capitalist.auctionUI.page = i
										Capitalist:UpdateAuctionUI()
									  end)
	t.prevButton:Disable()
	
	t.nextButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.nextButton:SetWidth(30)
	t.nextButton:SetHeight(20)
	t.nextButton:SetText(">>")
	t.nextButton:SetPoint("LEFT", t.prevButton, "RIGHT", 10, 0)
	t.nextButton:SetScript("OnClick", function()
									Capitalist.auctionUI.page = Capitalist.auctionUI.page + 1
									Capitalist:UpdateAuctionUI()
								  end)
	t.nextButton:Disable()
	
	t.cancelYellow = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelYellow:SetPoint("TOPLEFT", t.postButton, "BOTTOMLEFT", 0, -10)
	t.cancelYellow:SetScale(0.6)
	t.cancelYellow:SetChecked(self.db.profile.cancelYellow)
	t.cancelYellow:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelYellow = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelYellowLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelYellowLabel:SetPoint("LEFT", t.cancelYellow, "RIGHT")
	t.cancelYellowLabel:SetJustifyH("LEFT")
	t.cancelYellowLabel:SetText(L["cancel yellow auctions"])

	t.cancelBlue = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelBlue:SetPoint("TOPLEFT", t.cancelYellow, "BOTTOMLEFT", 0, 5)
	t.cancelBlue:SetScale(0.6)
	t.cancelBlue:SetChecked(self.db.profile.cancelBlue)
	t.cancelBlue:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelBlue = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelBlueLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelBlueLabel:SetPoint("LEFT", t.cancelBlue, "RIGHT")
	t.cancelBlueLabel:SetJustifyH("LEFT")
	t.cancelBlueLabel:SetText(L["cancel blue auctions"])

	t.cancelDuration = CreateFrame("CheckButton", nil, t, "UICheckButtonTemplate")
	t.cancelDuration:SetPoint("TOPLEFT", t.cancelBlue, "BOTTOMLEFT", 0, 5)
	t.cancelDuration:SetScale(0.6)
	t.cancelDuration:SetChecked(self.db.profile.cancelDuration)
	t.cancelDuration:SetScript("OnClick", function(self)
											Capitalist.db.profile.cancelDuration = self:GetChecked() == 1
											Capitalist:CheckForCancel()
										end)
	
	t.cancelDurationLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.cancelDurationLabel:SetPoint("LEFT", t.cancelDuration, "RIGHT")
	t.cancelDurationLabel:SetJustifyH("LEFT")
	t.cancelDurationLabel:SetText(L["cancel auctions that expire in 12h"])

	t.grayLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.grayLabel:SetPoint("TOPLEFT", t.postButton, "BOTTOMLEFT", 0, -120)
	t.grayLabel:SetTextColor(0.7, 0.7, 0.7)
	
	t.greenLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.greenLabel:SetPoint("TOPLEFT", t.grayLabel, "BOTTOMLEFT")
	t.greenLabel:SetTextColor(0, 1, 0)	
	
	t.yellowLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.yellowLabel:SetPoint("TOPLEFT", t.greenLabel, "BOTTOMLEFT")
	t.yellowLabel:SetTextColor(1, 1, 0)	
	
	t.orangeLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.orangeLabel:SetPoint("TOPLEFT", t.yellowLabel, "BOTTOMLEFT")
	t.orangeLabel:SetTextColor(1, 0.5, 0)	
	
	t.blueLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.blueLabel:SetPoint("TOPLEFT", t.orangeLabel, "BOTTOMLEFT")
	t.blueLabel:SetTextColor(0.4, 0.4, 1)	

	t.redLabel = t:CreateFontString(nil, nil, "GameFontNormal")
	t.redLabel:SetPoint("TOPLEFT", t.blueLabel, "BOTTOMLEFT")
	t.redLabel:SetTextColor(1, 0, 0)		

	self:DebugExit("CreateAuctionUI")
end

function Capitalist:ToggleAuctionUI()
	self:DebugEntry("ToggleAuctionUI")

	if (self.componentUI:IsVisible()) then
		self:ToggleComponentUI()
	end

	if (self.auctionUI:IsVisible()) then
		self.auctionUI:Hide()
		self.auctionUIButton.border:Hide()
		
		BrowseQualitySort:Show()
		BrowseLevelSort:Show()
		BrowseDurationSort:Show()
		BrowseHighBidderSort:Show()
		BrowseCurrentBidSort:Show()
	else
		self.auctionUI:Show()
		self.auctionUIButton.border:Show()
		
		BrowseQualitySort:Hide()
		BrowseLevelSort:Hide()
		BrowseDurationSort:Hide()
		BrowseHighBidderSort:Hide()
		BrowseCurrentBidSort:Hide()
	end

	self:DebugExit("ToggleAuctionUI")
end

function Capitalist:UpdateAuctionUI()
	self:DebugEntry("UpdateAuctionUI")

	local skillColor = {}
	local skillLowestOwner = {}
	local countOfColor = {gray = 0, green = 0, yellow = 0, orange = 0, blue = 0, red = 0}	
	
	if (self.db.profile[realm] and
		self.db.profile[realm][character]) then

		-- save, which products are on the AH (for restocking)
		local productsInAH = self.db.profile.storage[realm][character].AH
		for k, v in pairs(productsInAH) do
			productsInAH[k] = nil
		end
	
		for i = 1, GetNumAuctionItems("owner") do
			local name, _, _, _, _, _, _, _, buyoutPrice, _, _, _, saleStatus = GetAuctionItemInfo("owner", i)
			if (self.list[name] and saleStatus == 0) then
				if (not productsInAH[name]) then
					productsInAH[name] = 1
				else
					productsInAH[name] = productsInAH[name] + 1
				end
			end
		end
	
		for profession, professionData in pairs(self.db.profile[realm][character]) do
			for skillName, skillData in pairs(self.db.profile[realm][character][profession]) do
				local numCreated = skillData.numCreated or 0
				local product = self.db.profile.professions[profession][skillName]

				if (self:ProductIsVisible(profession, skillName) and
					self:ProductIsEnabled(profession, skillName) and
					product.count and
					product.count > 0) then

					local productName = skillName
					if (product.scroll) then
						productName = product.scroll
					end

					-- unknown - need to scan
					local color = "gray"
					local owner

					local v = self.list[productName]
					if (self.validScan) then
						if (productsInAH[productName]) then
				
							if (v.buyoutSelf == nil) then
								color = "gray"
							elseif ((v.buyoutOthers == nil) or (v.buyoutSelf < v.buyoutOthers)) then
								-- cheapest auction
								color = "green"
								owner = character
							elseif (v.buyoutOthers < v.bestPrice) then
								-- can't undercut cheapest auction
								color = "orange"
								owner = v.otherOwner
							elseif (v.buyoutSelf < v.bestPrice) then
								-- can repost for higher price
								color[skillName] = "blue"
								owner = character
							elseif (v.bestPrice < v.buyoutSelf) then
								-- undercut - need to repost
								color = "yellow"
								owner = v.otherOwner
							end
						else
							-- out of stock
							color = "red"
							owner = v.otherOwner
						end
					end
			
					skillColor[skillName] = color
					skillLowestOwner[skillName] = owner
					countOfColor[color] = countOfColor[color] + 1
				end
			end
		end
	
		-- sort auction list by name
		local sorted = {}
		for skillName, data in pairs(skillColor) do
			table.insert(sorted, skillName)
		end
		table.sort(sorted)
	
		-- check if we need to show previous/next-buttons
		local numPages = #sorted / countPerPageProductUI
	
		if (numPages < self.auctionUI.page) then
			self.auctionUI.page = numPages
		end
	
		if (self.auctionUI.page > 0) then
			self.auctionUI.prevButton:Enable()
		else
			self.auctionUI.prevButton:Disable()
		end
	
		if (self.auctionUI.page < numPages - 1) then
			self.auctionUI.nextButton:Enable()
		else
			self.auctionUI.nextButton:Disable()
		end
	
		local item = 0 - self.auctionUI.page * countPerPageProductUI
	
		for index, skillName in ipairs(sorted) do
			item = item + 1

			if (item > 0 and item <= countPerPageProductUI) then
				local profession = self:FindProfession(skillName)
				local product = self.db.profile.professions[profession][skillName]

				local productName = skillName
				if (product.scroll) then
					productName = product.scroll
				end

				local text = self.auctionUI.items[item].name
				local money = self.auctionUI.items[item].money
				local count = self.auctionUI.items[item].count
				local lowest = self.auctionUI.items[item].lowest

				if (profession == L["Enchanting"]) then
					text:SetText(L.stripSkillName(skillName))
				else
					text:SetText(skillName)
				end
			
				if (skillColor[skillName] ~= "gray" and skillColor[skillName] ~= "red") then
					local price = self:GetMoneyText(self.list[productName].buyoutSelf)
					local profit = self:GetMoneyText(self.list[productName].buyoutSelf - self.list[productName].cost, true)
				
					if (self.list[productName].buyoutOthers) then
						money:SetText(price.." ["..profit.."; "..self:GetMoneyText(self.list[productName].buyoutOthers - self.list[productName].buyoutSelf, true).."]")
					else
						money:SetText(price.." ["..profit.."]")
					end
				else
					money:SetText("")
				end
			
			
				local ownAuctions = productsInAH[productName] or 0
				if (self.validScan and self.list[productName].otherAuctions) then
					count:SetText("[ "..ownAuctions.." | "..#self.list[productName].otherAuctions.." ]")
				else
					count:SetText("[ "..ownAuctions.." ]")
				end

				lowest:SetText(skillLowestOwner[skillName])
			
			
				if (skillColor[skillName] == "gray") then
					text:SetTextColor(0.7, 0.7, 0.7)
					count:SetTextColor(0.7, 0.7, 0.7)
					money:SetTextColor(0.7, 0.7, 0.7)
					lowest:SetTextColor(0.7, 0.7, 0.7)
				elseif (skillColor[skillName] == "green") then
					text:SetTextColor(0, 1, 0)
					count:SetTextColor(0, 1, 0)
					money:SetTextColor(0, 1, 0)
					lowest:SetTextColor(0, 1, 0)
				elseif (skillColor[skillName] == "yellow") then
					text:SetTextColor(1, 1, 0)
					count:SetTextColor(1, 1, 0)
					money:SetTextColor(1, 1, 0)
					lowest:SetTextColor(1, 1, 0)
				elseif (skillColor[skillName] == "orange") then
					text:SetTextColor(1, 0.5, 0)
					count:SetTextColor(1, 0.5, 0)
					money:SetTextColor(1, 0.5, 0)
					lowest:SetTextColor(1, 0.5, 0)
				elseif (skillColor[skillName] == "blue") then
					text:SetTextColor(0.4, 0.4, 1)
					count:SetTextColor(0.4, 0.4, 1)
					money:SetTextColor(0.4, 0.4, 1)
					lowest:SetTextColor(0.4, 0.4, 1)
				elseif (skillColor[skillName] == "red") then
					text:SetTextColor(1, 0, 0)
					count:SetTextColor(1, 0, 0)
					money:SetTextColor(1, 0, 0)
					lowest:SetTextColor(1, 0, 0)
				end
			end 
		end
	
		if (item > 0 and item < countPerPageProductUI) then
			for i = item + 1, countPerPageProductUI do
				self.auctionUI.items[i].name:SetText("")
				self.auctionUI.items[i].count:SetText("")
				self.auctionUI.items[i].money:SetText("")
				self.auctionUI.items[i].lowest:SetText("")
			end
		end
	end
	
	self.auctionUI.grayLabel:SetText(string.format(L["%dx unknown - need to scan"], countOfColor.gray))
	self.auctionUI.greenLabel:SetText(string.format(L["%dx cheapest auction"], countOfColor.green))
	self.auctionUI.yellowLabel:SetText(string.format(L["%dx undercut - need to repost"], countOfColor.yellow))
	self.auctionUI.orangeLabel:SetText(string.format(L["%dx can't undercut cheapest auction"], countOfColor.orange))
	self.auctionUI.blueLabel:SetText(string.format(L["%dx can repost for higher price"], countOfColor.blue))
	self.auctionUI.redLabel:SetText(string.format(L["%dx out of stock"], countOfColor.red))

	self:DebugExit("UpdateAuctionUI")
end

function Capitalist:GetMoneyText(amount, sign, significantDigits)
	self:DebugEntry("GetMoneyText")

	if (amount == nil) then
		return ""
	end
	
	local str
	
	if (abs(amount) > 10000) then
		str = "g"
		amount = amount / 10000
	elseif (abs(amount) > 100) then
		str = "s"
		amount = amount / 100
	else
		str = "c"
	end
	
	if (not significantDigits) then
		amount = math.floor(amount + 0.5)
	else
		local factor = math.pow(10, significantDigits - 1)
		amount = math.floor(amount * factor) / factor
	end
	
	
	str = amount .. str
	
	if (sign and amount > 0) then
		str = "+"..str
	end
	
	return self:DebugExit("GetMoneyText", str)
end